<?
class Mail {

	var $sendto = array();
	var $acc = array();
	var $abcc = array();
	var $aattach = array();
	var $xheaders = array();
	var $priorities = array( '1 (Highest)', '2 (High)', '3 (Normal)', '4 (Low)', '5 (Lowest)' );
	var $charset = "windows-1251";
	var $ctencoding = "8bit";
	var $receipt = 0;
	var $articles_type='text/plain';

// 
function Mail() {

	$this->boundary= "--" . md5( uniqid("myboundary") );
}


function articles_type($articlestype) {

	$this->articles_type=$articlestype;
}

// 
function Subject( $subject ) {

	$this->xheaders['Subject'] = strtr( $subject, "\r\n" , "  " );
}

// 
function From( $from ) {

	$this->xheaders['From'] = $from;
}

// 
function ReplyTo( $address ) {

	if( ! is_string($address) ) return false;

	$this->xheaders["Reply-To"] = $address;
}


function Receipt() {

	$this->receipt = 1;
}

// 
function To( $to ) {

	if( is_array( $to ) ) {
		$this->sendto= $to;
	} else {
		$this->sendto[] = $to;
	}
}


function Cc( $cc ) {

	if( is_array($cc) ) {
 		$this->acc= $cc;
 	} else {
		$this->acc[]= $cc;
	}
}


function Bcc( $bcc ) {

	if( is_array($bcc) ) {  $this->abcc = $bcc; } else { $this->abcc[]= $bcc; }
}

//  
function Body( $body, $charset="" ) {

	$this->body = $body;

	if( $charset != "" ) {
		$this->charset = strtolower($charset);
		if( $this->charset != "us-ascii" ) $this->ctencoding = "8bit";
	}
}


function Organization( $org ) {

	if( trim( $org != "" )  ) $this->xheaders['Organization'] = $org;
}

// 
function Priority( $priority ) {

	if( ! intval( $priority ) )  return false;

	if( ! isset( $this->priorities[$priority-1]) ) return false;

	$this->xheaders["X-Priority"] = $this->priorities[$priority-1];

return true;
}

//  
function Attach($filename,$filetype = "",$disposition = "inline") {

	if( $filetype == "" ) $filetype = "application/x-unknown-Content-type";

	$this->aattach[] = $filename;

	$this->actype[] = $filetype;
	$this->adispo[] = $disposition;
}

//   
function BuildMail() {

	$this->headers = "";

	if( count($this->acc) > 0 ) $this->xheaders['CC'] = implode( ", ", $this->acc );

	if( count($this->abcc) > 0 ) $this->xheaders['BCC'] = implode( ", ", $this->abcc );

	if( $this->receipt ) {
		if( isset($this->xheaders["Reply-To"] ) )  $this->xheaders["Disposition-Notification-To"] = $this->xheaders["Reply-To"];
                	else  $this->xheaders["Disposition-Notification-To"] = $this->xheaders['From'];
	}

	if( $this->charset != "" ) {

		$articles_type=$this->articles_type;
		$this->xheaders["Mime-Version"] = "1.0";
		$this->xheaders["articles-Type"] = "$articles_type; charset=$this->charset";
		$this->xheaders["articles-Transfer-Encoding"] = $this->ctencoding;
	}

	$this->xheaders["X-Mailer"] = "PHP Mailer";

	if( count( $this->aattach ) > 0 ) {
		$this->_build_attachement();
	} else {
		$this->fullBody = $this->body;
	}

	reset($this->xheaders);
	while( list( $hdr,$value ) = each( $this->xheaders )  ) {
	if( $hdr != "Subject" )
		$this->headers .= "$hdr: $value\n";
	}
}

// 
function Send() {

	$this->BuildMail();
	$this->strTo = implode( ", ", $this->sendto );
	$res = @mail( $this->strTo, $this->xheaders['Subject'], $this->fullBody, $this->headers );
}


function Get() {

	$this->BuildMail();
	$mail = "To: " . $this->strTo . "\n";
	$mail .= $this->headers . "\n";
	$mail .= $this->fullBody;
	return $mail;
}


function _build_attachement() {

	$this->xheaders["articles-Type"] = "multipart/mixed;\n boundary='".$this->boundary."'";

	$this->fullBody = "This is a multi-part message in MIME format.\n--$this->boundary\n";
	$this->fullBody .= "articles-Type: ".$this->articles_type."; charset=$this->charset\narticles-Transfer-Encoding: $this->ctencoding\n\n" . $this->body ."\n";

	$sep= chr(13) . chr(10);

	$ata= array();
	$k=0;

	for( $i=0; $i < count( $this->aattach); $i++ ) {

		$filename = $this->aattach[$i];
		$basename = basename($filename);
		$ctype = $this->actype[$i];
		$disposition = $this->adispo[$i];

		if( ! file_exists( $filename) ) {
			print ":    ."; exit;
		}

		$subhdr= "--$this->boundary\narticles-Type: $ctype;\n name='".$basename."';\narticles-Transfer-Encoding: base64\narticles-Disposition: $disposition;\n  filename='".$basename."'\n";
		$ata[$k++] = $subhdr;

		$linesz= filesize( $filename)+1;
		$fp= fopen( $filename, 'r' );
		$ata[$k++] = chunk_split(base64_encode(fread( $fp, $linesz)));

		fclose($fp);
	}

	$this->fullBody .= implode($sep, $ata);
}


}
?>