<?
/*===============================================================================
  
===============================================================================*/
function _html_modules() {

	global $sql, $gbl_config;

	$result=$sql->exec("SELECT * FROM ".$gbl_config['sql_db'].".system_modules WHERE is_show='1';");
		if($sql->error)  _message($sql->error, '', '', 'error');

	while($data=$result->fetch_array())
	{
		$array_modules[] = implode("|", $data);
	}

	$result->free_result();

return $array_modules;
}

/*===============================================================================
   
===============================================================================*/
function _html_design($text) {

	global $gbl_config, $tpl_nav, $gbl_var, $session_user, $init_editor;

	include_once("./themes/".$gbl_config[themes]."/system_header.htm");

	$left_menu = _blocks("l");
	$right_menu = _blocks("r");
	$top_menu = _blocks("u");
	$bottom_menu = _blocks("d");

	print preg_replace("/{%(\w+)%}/ee", "$\\1",_html("./themes/".$gbl_config[themes]."/system_main.htm",0));
	print "\n<script language=\"JavaScript\">\n<!-- \ndocument.write('<img src=\"http://www.dementiev.com/robots/callhome.php?prod=sitemanager&rnd='+Math.random()+'&ref='+escape(document.URL)+'\" width=1 height=1>')\n//-->\n</script>\n";

	include_once("./themes/".$gbl_config[themes]."/system_footer.htm");
}

/*===============================================================================
 
===============================================================================*/
function _blocks($pos) {

	global $sql, $menu_html, $gbl_config, $gbl_var, $session_user;

	$result=$sql->exec("SELECT * FROM ".$gbl_config['sql_db'].".system_blocks WHERE position='".$pos."' AND is_show=1 AND (view = '".$session_user['typeid']."' OR view='-1') AND (view_mod = '".$gbl_var["mod"]."' OR view_mod='all') ORDER BY weight ASC;");
		if($sql->error)  _message($sql->error, '', '', 'error');

	unset($html);
	unset($menu_html);

	while($data=$result->fetch_array())
	{
		extract($data);

		if ($mod) {
			include("./modules/".$mod."/menu/".$file);	
		} else {
			$handle = fopen ($file, "r");
			$menu_html .= fread ($handle, 1000000);
			fclose ($handle);
		}
	}
	$result->free_result();

return $menu_html;
}

/*===============================================================================
    
===============================================================================*/
function _message($string, $value, $url, $log) {

	global $gbl_config, $gbl_var, $session_user;

	if (!$url) $url = getenv("HTTP_REFERER");

	// Log 
	if ($gbl_config['log']) {
		_logfile($log, $string."\n");
	}

	if ($value) { $value = sprintf("'%s'", $value); }

	$string_temp = _striptags(array($string));
	$string_temp[0] = strip_tags($string_temp[0]);

	$string = sprintf("%s <b>%s</b>", $string_temp[0], $value);

	$temp_html = preg_replace("/{%(\w+)%}/ee", "$\\1",_html("./themes/".$gbl_config[themes]."/system_message.htm",0));
	print preg_replace("/<%(\w+)%>/ee", "\\1", $temp_html);

exit;
}

/*===============================================================================
 
===============================================================================*/
function _html($path,$htmlescape) {

	if(!file_exists($path))
	{
		die(_ERROR_OPENFILE.": '".$path."'");
	}
	$fp=fopen($path,"r");
	$articless=fread($fp,filesize($path));
	if($htmlescape == 1)
	{
		$articless=htmlspecialchars($articless);
	}
	unset($path);

return $articless;
}

/*===============================================================================
 
===============================================================================*/
function _span($span,$page,$totalsize,$url){

	$nPages=floor($totalsize/$span);
	if($totalsize%$span>0){$nPages++;}
	if ($nPages<=1)  { $span_display=""; }
	else
	{
		$next_numb=$page+1;$pre_numb = $page-1;
		$code.="<small><hr size=1>"._PAGES.": ";

		if ($page!=1)	{ $code.="[<b><a href='".$url."&page=".$pre_numb."'>&#171;</a></b>] &nbsp;"; }
		else		{ $code.=''; }
		if ($nPages >12)
		{
			$startpage=$page-6;$endspan=$page+6;
			if ($startpage<=0)	{ $startpage=1;$endspan=12; }
			else		{ $startpage=$page-6; }
			if ($endspan > $nPages) { $endspan=$nPages;$startpage=$nPages-12; }
		}
		else
		{
			$startpage=1;$endspan=$nPages;
		}
		for ($s=$startpage;$s<=$endspan;$s++)
		{
			if ($s!=$page)	{$code.=" | <a href='".$url."&page=".$s."'>".$s."</a> ";}
			else		{$code.=" | <b>$s</b> ";}
		}
		if ($nPages >12)   { if ($endspan != $nPages){$code.=" <b>...</b> ";} }
		if ($page!=$nPages)	{$code.=" &nbsp;[<b><a href='".$url."&page=".$next_numb."'>&#187;</a></b>]";}
		else			{ $code.=''; }
		$code.="<hr size=1>";
	}

	$code .="</small>";

return $code;
}

/*===============================================================================
 
===============================================================================*/
function _sort($sort_array, $url) {

	global $gbl_config, $gbl_var;

	unset($no_sort);

	foreach ($sort_array as $key => $val) {

		if (!$gbl_var["sort"]) {
			if (!$no_sort)	{ $code_array[]= "<u>".$val."</u>"; $no_sort++; }
			else		{ $code_array[]= "<a href=".$url."&sort=".$key."&by=".$gbl_var["by"].">".$val."</a>"; }
		} else {
			if ($gbl_var["sort"] == $key)	{ $code_array[]= "<u>".$val."</u>"; }
			else			{ $code_array[]= "<a href=".$url."&sort=".$key."&by=".$gbl_var["by"].">".$val."</a>"; }
		}
	}

	$code .= _SORT.implode(", ", $code_array)."<br>"._SORT_BY;

	if ($gbl_var["by"])	{ $code .= "<u>"._UP."</u>, <a href=".$url."&sort=".$gbl_var["sort"]."&by=0>"._DOWN."</a>"; }
	else		{ $code .= "<a href=".$url."&sort=".$gbl_var["sort"]."&by=1>"._UP."</a>, <u>"._DOWN."</u>"; }

return $code;
}

/*===============================================================================
 
===============================================================================*/
function _search($search_array, $url) {

	global $gbl_var;

	$code  ="<form method=POST action=".$url." enctype=multipart/form-data>";
	$code .= _SEARCH. "<select name=stype>";

	foreach ($search_array as $key => $val) {
		if ($gbl_var["stype"] == $key)	{  $code .= "<option value=".$key." selected>".$val."</option> "; }
		else 			{  $code .= "<option value=".$key.">".$val."</option> "; }
	}

	$code .= "</select> <input type=text name=keywords size=13 value='".$gbl_var["keywords"]."'> <input type=submit value='>>'></form>";

return $code;
}
?>