<?
/*===============================================================================
  
===============================================================================*/
function _logfile($type, $string) {

	global $gbl_var, $session_user;

	$string=stripslashes($string);
	$string=strip_tags($string);
	$string=preg_replace("/\n/","",$string);	
	$string=preg_replace("/\r/","",$string);
	$string=preg_replace("/>/",">\n",$string);

	while ( list( $key, $val ) = each( $gbl_var ) )	{ $var_format[]= $key."=".$val; }

	$rec_log=0;

	switch ($type) {
		case "error":
			$out_format[] = date("d-m-Y h:i:s");
			$out_format[] = $string;
			$out_format[] = "\tUser: id=".$session_user['id'].", login=".$session_user['login'].", type=".$session_user['type'];
			$out_format[] = "Query: ".implode(", ", $var_format);

			$out_string = implode("\t", $out_format);
			$rec_log=1;
		break;
		case "access":
			$out_format[] = date("d-m-Y h:i:s");
			$out_format[] = $string;
			$out_format[] = "\tUser: id=".$session_user['id'].", login=".$session_user['login'].", type=".$session_user['type'];

			$out_string = implode("\t", $out_format);
			$rec_log=1;
		break;
		default:
			$rec_log=0;
		break;

	}

	if ($rec_log) {
		$fp = fopen("./log/".$type.".txt", "a+");
		fwrite($fp, $out_string."\n");
		fclose($fp);
	}
}

/*===============================================================================
  
===============================================================================*/
function _permission($mod, $permission) {

	global $sql, $gbl_config, $session_user;

	$result=$sql->exec("SELECT COUNT(*) FROM ".$gbl_config['sql_db'].".system_blocks WHERE mod='".$mod."' AND file='".$permission.".php' AND (view = '".$session_user['typeid']."' OR view='-1');");
		if($sql->error)  _message($sql->error, '', '', 'error');
	$totalrec=$result->fetch_row();
	$result->free_result();

	if (!$totalrec[0])
	{
		_message(_ERROR_PERMISSION, '', './', 'error');
	}
}

/*===============================================================================
  
===============================================================================*/
function _date($timestamp, $format) {

	global $lang_mount, $lang_day;

	$in_date_d = $lang_day[ date("D", $timestamp) ];
	$in_date_ch= date(" j ",$timestamp);
	$in_date_mon= $lang_mount[ date("F", $timestamp) ];
	$in_date_year= date(" Y", $timestamp);

	switch($format) {
		case 1:
			return $in_date_d.", ".$in_date_ch.$in_date_mon.$in_date_year;
		break;
	}

return "&#151;";
}

/*===============================================================================
  
===============================================================================*/
function _getfilemimetype($field) {

	global $HTTP_POST_FILES;

return $HTTP_POST_FILES[$field]['type'];
}

/*===============================================================================
  
===============================================================================*/
function _getfilesize($field) {

	global $HTTP_POST_FILES;

return $HTTP_POST_FILES[$field]['size'];
}

/*===============================================================================
  
===============================================================================*/
function _striptags($string_array) {

	foreach ($string_array as $string) {

		$string = strip_tags($string);
		$string = ereg_replace("<","&lt;",$string);
		$string = ereg_replace('\\\"',"&quot;",$string);
		$string = ereg_replace('\\"',"&quot;",$string);
		$string = ereg_replace("!","&#33;",$string);
		$string = ereg_replace("\r\n","<br>",$string);
		$string = ereg_replace("\n","<br>",$string);
		$string = ereg_replace("%","&#37;",$string);
		$string = ereg_replace("^ +","",$string);
		$string = ereg_replace(" +$","",$string);
		$string = ereg_replace(" +"," ",$string);
		$string = str_replace('\"','&quot;',$string);
		$string = str_replace("\'","&quot;",$string);
		$string = str_replace("\&","&",$string);
		
		$out_string_array[] = $string;
	}

return $out_string_array;
}

/*===============================================================================
   
===============================================================================*/
function _existinput($string_array) {

	foreach ($string_array as $string) {
		
		if(!isset($string)) {  _message(" .", '', 'index.php', 'no');  }

	}

return 1;
}

/*===============================================================================
    
===============================================================================*/
function _detect() { return 1; }

/*===============================================================================
    ()
===============================================================================*/
function addNode($parentNode, $recursedNodes) {
	
	global $tree_array, $out_tables, $gbl_config, $gbl_var;

	for ($i=0; $i<count($tree_array); $i++) {
		$nodeValues = split("\|", $tree_array[$i]);
		if ($nodeValues[1] == $parentNode) {

			$otst = '';
			for ($g=0; $g<count($recursedNodes); $g++) {
				$otst .= "&#133;";
			}
			array_push($recursedNodes, 0);		

			$out_tables.="
			<tr>
			<td><img border='0' src=./themes/".$gbl_config[themes]."/images/active.gif></td>
			<td width=100%>$otst <b>$nodeValues[2]</b></td>
			<td nowrap><a href=\"javascript:del_confirm('index.php?mod=$gbl_var[mod]&go=$gbl_var[go]&action=del&id=$nodeValues[0]')\"><img border=0 src=./themes/".$gbl_config[themes]."/images/del.gif alt='"._DEL."'></a>&nbsp;<a href=index.php?mod=$gbl_var[mod]&go=$gbl_var[go]&action=edit&id=$nodeValues[0]><img border=0 src=./themes/".$gbl_config[themes]."/images/edit.gif alt='"._EDIT."'></a>&nbsp;<a href='index.php?mod=".$gbl_var[mod]."&go=".$gbl_var[go]."&action=sub&id=".$nodeValues[0]."'><img border=0 src=./themes/".$gbl_config[themes]."/images/folder.gif alt='"._SUBSECTION_ADD."'></a></td>
			<td valign=top>&nbsp;</td>
			</tr>
			<tr bgcolor=#CCCCCC><td colspan=5><img src=./themes/".$gbl_config[themes]."/images/pixel.gif></td></tr>";
	
			addNode($nodeValues[0], $recursedNodes);		
			array_pop ($recursedNodes);
		}
	}
}
?>