<?
include("lang.php");
?>

<html style="width: 398; height: 218">

<head>
  <title><? print _TABLE; ?></title>

<script type="text/javascript" src="popup.js"></script>

<script type="text/javascript">

function Init() {
  __dlg_init();
  document.getElementById("f_rows").focus();
};

function onOK() {
  var required = {
    "f_rows": "You must enter a number of rows",
    "f_cols": "You must enter a number of columns"
  };
  for (var i in required) {
    var el = document.getElementById(i);
    if (!el.value) {
      alert(required[i]);
      el.focus();
      return false;
    }
  }
  var fields = ["f_rows", "f_cols", "f_width", "f_unit",
                "f_align", "f_border", "f_spacing", "f_padding"];
  var param = new Object();
  for (var i in fields) {
    var id = fields[i];
    var el = document.getElementById(id);
    param[id] = el.value;
  }
  __dlg_close(param);
  return false;
};

function onCancel() {
  __dlg_close(null);
  return false;
};

</script>

<style type="text/css">
html, body {
  background: ButtonFace;
  color: ButtonText;
  font: 11px Tahoma,Verdana,sans-serif;
  margin: 0px;
  padding: 0px;
}
body { padding: 5px; }
table {
  font: 11px Tahoma,Verdana,sans-serif;
}
form p {
  margin-top: 5px;
  margin-bottom: 5px;
}
.fl { width: 9em; float: left; padding: 2px 5px; text-align: right; }
.fr { width: 7em; float: left; padding: 2px 5px; text-align: right; }
fieldset { padding: 0px 10px 5px 5px; }
select, input, button { font: 11px Tahoma,Verdana,sans-serif; }
button { width: 70px; }
.space { padding: 2px; }

.title { background: #666666; color: #FFFFFF; font-weight: bold; font-size: 120%; padding: 3px 10px; margin-bottom: 10px;
border-bottom: 1px solid black; letter-spacing: 2px;
}
form { padding: 0px; margin: 0px; }
</style>

</head>

<body onload="Init()">

<div class="title"><? print _TABLE; ?></div>

<form action="" method="get">
<table border="0" style="padding: 0px; margin: 0px">
  <tbody>

  <tr>
    <td style="width: 4em; text-align: right"><? print _ROWS; ?>:</td>
    <td><input type="text" name="rows" id="f_rows" size="5" value="2" /></td>
    <td></td>
    <td></td>
    <td></td>
  </tr>
  <tr>
    <td style="width: 4em; text-align: right"><? print _COLS; ?>:</td>
    <td><input type="text" name="cols" id="f_cols" size="5" value="4" /></td>
    <td style="width: 4em; text-align: right"><? print _WIDTH; ?>:</td>
    <td><input type="text" name="width" id="f_width" size="5" value="100" /></td>
    <td><select size="1" name="unit" id="f_unit">
      <option value="%" selected="1"  >%</option>
      <option value="px"              >Px</option>
      <option value="em"              >Em</option>
    </select></td>
  </tr>

  </tbody>
</table>

<p />

<fieldset style="float: left; margin-left: 5px;">
<legend><? print _LAYOUT; ?></legend>

<div class="space"></div>

<div class="fl"><? print _ALIGNMENT; ?>:</div>
<select size="1" name="align" id="f_align">
  <option value="" selected="1"                >Not set</option>
  <option value="left"                         >Left</option>
  <option value="right"                        >Right</option>
  <option value="texttop"                      >Texttop</option>
  <option value="absmiddle"                    >Absmiddle</option>
  <option value="baseline"                     >Baseline</option>
  <option value="absbottom"                    >Absbottom</option>
  <option value="bottom"                       >Bottom</option>
  <option value="middle"                       >Middle</option>
  <option value="top"                          >Top</option>
</select>

<p />

<div class="fl"><? print _BORDER; ?>:</div>
<input type="text" name="border" id="f_border" size="5" value="1">
<!--
<p />

<div class="fl">Collapse borders:</div>
<input type="checkbox" name="collapse" id="f_collapse" />
-->
<div class="space"></div>

</fieldset>

<fieldset style="float:right; margin-right: 5px;">
<legend><? print _SPACING; ?></legend>

<div class="space"></div>

<div class="fr">Spacing:</div>
<input type="text" name="spacing" id="f_spacing" size="5" value="1">

<p />

<div class="fr">Padding:</div>
<input type="text" name="padding" id="f_padding" size="5" value="1">

<div class="space"></div>

</fieldset>

<div style="margin-top: 85px; text-align: right;">
<hr />
<button type="button" name="ok" onclick="return onOK();"><? print _NEXT; ?></button>
<button type="button" name="cancel" onclick="return onCancel();"><? print _CANCEL; ?></button>
</div>

</form>

</body>
</html>
